<script>  
  	import { onMount } from 'svelte';

    const appid_openweather = "ac0fdd38df429674be21355a4850114b";
    const dateObj = new Date();
    const days = ['Sunday','Monday','Tuesday','Wednesday','Thursday','Friday','Saturday'];
    const dayOfTheWeek = days[dateObj.getDay()];
    const date = dateObj.getDate() + ' ' + dateObj.toLocaleString('en-us', { month: "short" }) + ' ' + dateObj.getFullYear();
    let loading = false;
    let sunrise = "";
    let sunset = "";
    let weatherData = null;


    const getLocation = () => {
      navigator.geolocation.getCurrentPosition((position) => {
        let lat = position.coords.latitude;
        let lon = position.coords.longitude;

        fetchWeather(lat, lon)
      });
    }

    const fetchWeather = async (lat, lon) => {
      await fetch(`http://api.openweathermap.org/data/2.5/weather/?lat=${lat}&lon=${lon}&units=metric&APPID=${appid_openweather}`)
        .then(res => res.json())
        .then(result => {
          loading = false;
          console.log(result);
          weatherData = result;
          sunset = new Date(weatherData.sys.sunset * 1000).toLocaleTimeString('fr-FR');
          sunrise = new Date(weatherData.sys.sunrise * 1000).toLocaleTimeString('fr-FR');
        }) 
        .catch(err => {
          console.log(err.response);
          loading = false;
          window.alert(err.response.data.message);
        });
    }
    onMount(async () => {
      loading = true;
      getLocation();
      
    })
  </script>
  
  <style>
    @import url('https://fonts.googleapis.com/css2?family=Recursive&display=swap');

.main{
    width: 700px;
    border-radius: 20px;
    background-color: #01579b;
}

.top{
    height: 60px;
    background-color: #424242;
    color: whitesmoke;
    padding: 10px;
    border-radius: 20px 20px 0 0;
    font-family: 'Recursive', sans-serif;
    display: flex;
    justify-content: space-between;
}

.header{
    background-color: #424242;
    color: whitesmoke;
    margin: 10px 0px 0px 10px;
    font-size: 25px;
    border-radius: 20px 20px 0 0;
    font-family: 'Recursive', sans-serif;
}

.day{
    padding: 15px;
    color: whitesmoke;
    font-family: 'Recursive', sans-serif;
    font-size: 24px;
    font-weight: 600;
}

.temp{
    padding: 15px;
    color: whitesmoke;
    font-family: 'Recursive', sans-serif;
    font-size: 18px;
}

.flex{
    display: flex;
    justify-content: space-between;
}

.sunrise-sunset{
    padding: 15px;
    color: whitesmoke;
    font-family: 'Recursive', sans-serif;
    font-size: 16px;
}

.description{
    padding: 15px;
    color: whitesmoke;
    font-family: 'Recursive', sans-serif;
    font-size: 24px;
    font-weight: 600;
}
  </style>
  
  <div class="main">
  
    {#if loading}
      <div class="loader" />
    {/if}
  
    {#if weatherData!==null}
    <div class="top">
      <p class="header">{weatherData.name}</p>
    </div>
    <div class="flex">
      <p class="day">{dayOfTheWeek}, <span>{date}</span></p>
      <p class="description">{weatherData.weather[0].main}</p>
    </div>

    <div class="flex">
      <p class="temp">Temperature: {weatherData.main.temp} &deg;C</p>
      <p class="temp">Humidity: {weatherData.main.humidity} %</p>
    </div>

    <div class="flex">
      <p class="sunrise-sunset">Sunrise: {sunrise}</p>
      <p class="sunrise-sunset">Sunset: {sunset}</p>
    </div>
    {/if}
  
  </div>